﻿using System;
using System.Configuration;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Data.OleDb;

namespace iqbalAddin
{
/// <summary>
/// Summary description for Database
/// </summary>
    public class DataBase : IDisposable
    {
        private OleDbConnection myCon;
        private DataSet dSet;
        private OleDbCommand cmd;
        private OleDbDataReader dReader;
        private bool mbDisposed = false;

        public string StrException;
        public bool isConnected;
        public bool isError;
        private static string _pathAppData = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)+ "\\Iqbal Academy Pakistan\\Word Addin\\";
        //public string strConnString = "Data Source="+ BasePaths.pathAppData +"Quran.mdb;Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Database Password=a";
        public string strConnString = "Data Source=" + _pathAppData + "iqbalsworksecure.mdb;Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Database Password=Irfan123";
        //public string strConnStringAccess = "Data Source=quran.mdb;Provider=Microsoft.Jet.OLEDB.4.0";
        public DataBase()
        {
           
            isError = false;
            isConnected = false;
          //  string strConnString = "DSN=SMJSERVER;uid=sa;pwd=Cro@t!a";
            this.myCon = new OleDbConnection(strConnString);
            try
            {
                myCon.Open();
                StrException = "";
                isConnected = true;
            }
            catch (System.Data.OleDb.OleDbException ex)
            {
                string str;
                str = "Source:" + ex.Source;
                str += "\n" + "Message:" + ex.Message;
                StrException = str;
                isConnected = false;
            }
        }
        ~DataBase()
        {
            Dispose();
        }

        public void Dispose()
        {
            if (!mbDisposed)
            {
                try
                {
                    myCon.Close();
                    myCon.Dispose();
                }
                catch (System.Exception)
                {
                    // do nothing
                }
                finally
                {
                    mbDisposed = true;
                    GC.SuppressFinalize(this);
                }
            }
        }


        public bool query(string q)
        {
            cmd = new OleDbCommand();
            cmd.CommandText = q;
            cmd.Connection = myCon;
            try
            {
                dReader = cmd.ExecuteReader();
                this.isError = false;
                return true;
            }
            catch (System.Data.OleDb.OleDbException ex)
            {
                string str;
                str = "Source:" + ex.Source;
                str += "\n" + "Message:" + ex.Message;
                StrException = str;
                isError = true;
                return false;
            }

        }


        public void close()
        {
            if (myCon.State == ConnectionState.Open)
            {
                try
                {
                    myCon.Close();
                }
                catch (System.Data.OleDb.OleDbException ex)
                {
                    string str;
                    str = "Source:" + ex.Source;
                    str += "\n" + "Message:" + ex.Message;
                    StrException = str;
                }
            }
        }
        public System.Data.OleDb.OleDbDataReader GetDataReaders(string sSql)
        {
            //OleDbConnection Conn = new OleDbConnection(msConnectionString);
           // Conn.Open();
            OleDbCommand Comm = myCon.CreateCommand();
            Comm.CommandText = sSql;

            return Comm.ExecuteReader(CommandBehavior.SequentialAccess);
        }

        private System.Data.OleDb.OleDbDataReader GetDataReader(string sSql)
        {
            //OleDbConnection Conn = new OleDbConnection(msConnectionString);
            //Conn.Open();
            OleDbCommand Comm = myCon.CreateCommand();
            Comm.CommandText = sSql;

            return Comm.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
        }
        public System.Data.DataSet GetDataSet(string sSql)
        {
            return GetDataSet(sSql, null);
        }

        // returns datatable object 
        public System.Data.DataTable GetDataTable(string sSql)
        {
            System.Data.DataTable dt = new DataTable();
            //OleDbDataAdapter da = new OleDbDataAdapter(sSql, msConnectionString);
            OleDbDataAdapter da = new OleDbDataAdapter(sSql, myCon);
            try
            {
                da.Fill(dt);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return dt;
        }
        public System.Data.DataSet GetDataSet(string sSql, string sTableName)
        {
            System.Data.DataSet ds = new DataSet();
            //OleDbDataAdapter da = new OleDbDataAdapter(sSql, msConnectionString);
            OleDbDataAdapter da = new OleDbDataAdapter(sSql, myCon);
            try
            {
                if (sTableName == null)
                {
                    da.Fill(ds);
                }
                else
                {
                    da.Fill(ds, sTableName);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return ds;
        }

        public int ExecuteNonQuery(string sSql, out string ErrorMsg)
        {
            ErrorMsg = string.Empty;
            try
            {
                OleDbCommand Comm = myCon.CreateCommand();
                Comm.CommandText = sSql;
                return Comm.ExecuteNonQuery();
            }
            catch (System.Exception e)
            {
                ErrorMsg = e.Message;
                /*
                AuthMail oAuthMail = new AuthMail();
                string message = " Error : " + ErrorMsg + "\n\n Query: " + sSql;
                oAuthMail.mail("syedalikashif@gmail.com", "SMJ INSERT ERROR",message);
                oAuthMail.mail("talk2urfi@hotmail.com", "SMJ INSERT ERROR", message);
                 */
                return 0;
            }
        } // end executenonquery

        /*********************************************************
         * Execute_SQL()
         * input: SQL statement constructed in DBGet_Directions()
         * output: true/false
         ********************************************************/
        public void Execute_SQL(out DataSet ds, string sSql)
        {
            // initialize out-variables
            ds = null;
            try
            {
                ds = GetDataSet(sSql);
                if (ds == null || ds.Tables[0].Rows.Count <= 0)
                    throw new UserException("No Records Found");
            }
            catch { }
        } // end function

        /*********************************************************
         * Execute_SQL()
         * input: SQL statement constructed in DBGet_Directions()
         * output: true/false
         ********************************************************/
        public void Execute_SQL1(out DataTable dt, string sSql)
        {
            // initialize out-variables
            dt = null;
            try
            {
                dt = GetDataTable(sSql);
                if (dt == null || dt.Rows.Count <= 0)
                    throw new UserException("No Records Found");
            }
            catch { }
        } // end function

        public bool ExecuteScalar(string sSql, out object Result, out string ErrorMsg)
        {
            Result = null;
            ErrorMsg = string.Empty;
            try
            {
                OleDbCommand Comm = myCon.CreateCommand();
                Comm.CommandText = sSql;

                Result = Comm.ExecuteScalar();
                return true;
            }
            catch (System.Exception e)
            {
                ErrorMsg = e.Message;
                return false;
            }
        } // end executescalar

    //=============================================================================
        public System.Data.OleDb.OleDbDataReader GetDataSet(string[] parmaName, string[] parmaValue, string StoredProcedureName)
        {
            try
            {
                OleDbCommand cmd = new OleDbCommand(StoredProcedureName, myCon);
                cmd.CommandType = CommandType.StoredProcedure;

                if (parmaName.Length > 0 && parmaName.Length == parmaValue.Length)
                {
                    for (int i = 0; i < parmaName.Length; i++)
                    {
                        cmd.Parameters.Add(new SqlParameter("@" + parmaName[i], parmaValue[i]));
                    }
                }

                dReader = cmd.ExecuteReader();

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return dReader;
        }
        public System.Data.DataTable GetDataSetforGrid(string[] parmaName, string[] parmaValue, string StoredProcedureName)
        {
            System.Data.DataTable ds = new DataTable();
            try
            {
                OleDbCommand cmd = new OleDbCommand(StoredProcedureName, myCon);
                cmd.CommandType = CommandType.StoredProcedure;

                if (parmaName.Length > 0 && parmaName.Length == parmaValue.Length)
                {
                    for (int i = 0; i < parmaName.Length; i++)
                    {
                        cmd.Parameters.Add(new SqlParameter("@" + parmaName[i], parmaValue[i]));
                    }
                }
                //OleDbDataAdapter da = new OleDbDataAdapter(sSql, msConnectionString);
                OleDbDataAdapter da = new OleDbDataAdapter();
                da.SelectCommand = cmd;
                da.Fill(ds);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return ds;
        }

        //return datareader object by using stored procedure
        public OleDbDataReader GetReader(string[] parmaName, string[] parmaValue, string StoredProcedureName)
        {
            OleDbCommand cmd = new OleDbCommand();
                
            try
            {

                cmd.Connection = myCon;
                cmd.CommandText = StoredProcedureName;

                cmd.CommandType = CommandType.StoredProcedure;

                if (parmaName.Length > 0 && parmaName.Length == parmaValue.Length)
                {
                    for (int i = 0; i < parmaName.Length; i++)
                    {
                        cmd.Parameters.Add(new SqlParameter("@" + parmaName[i], parmaValue[i]));
                    }
                }
                
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return cmd.ExecuteReader();
        }

        //public void AddComboItems(string p_tablename, string p_displaymember, string p_valuemember, string p_filter, System.Web.UI.WebControls.DropDownList Combo)
        //{
        //    //This function used to get a dataset, which can be used to populate the control like combobox
        //    //Parameter: 
        //    //p_tablename. The table name from where the data need to popluate.
        //    //p_DisplayMember. The display field. This is the filed the combox will display.
        //    //p_ValueMember. The value member property. This stored the ID field we passed in.
        //    //Combo. The name of the combo box. This function fills the data in to this combo box
        //    //This function will only display one field value in the combbox


        //    OleDbDataAdapter dataadapter = new OleDbDataAdapter("SELECT " + p_displaymember + "," + p_valuemember + " FROM " + p_tablename + p_filter + " ORDER BY 1", myCon);
        //    DataSet dataset = new DataSet();
        //    dataadapter.Fill(dataset, p_tablename);
        //    Combo.DataSource = dataset;
        //    Combo.DataTextField = dataset.Tables[0].Columns[0].ColumnName.ToString();
        //    Combo.DataValueField = dataset.Tables[0].Columns[1].ColumnName.ToString();
        //    Combo.DataBind();

        //}

        //public void AddComboItemsPlus(string p_query, string p_displaymember, string p_valuemember, System.Web.UI.WebControls.DropDownList Combo)
        //{
        //    //This function used to get a dataset, which can be used to populate the control like combobox
        //    //Parameter: 
        //    //p_tablename. The table name from where the data need to popluate.
        //    //p_DisplayMember. The display field. This is the filed the combox will display.
        //    //p_ValueMember. The value member property. This stored the ID field we passed in.
        //    //Combo. The name of the combo box. This function fills the data in to this combo box
        //    //This function will only display one field value in the combbox


        //    OleDbDataAdapter dataadapter = new OleDbDataAdapter(p_query , myCon);
        //    DataSet dataset = new DataSet();
        //    dataadapter.Fill(dataset, p_query);
        //    Combo.DataSource = dataset;
        //    Combo.DataTextField = dataset.Tables[0].Columns[0].ColumnName.ToString();
        //    Combo.DataValueField = dataset.Tables[0].Columns[1].ColumnName.ToString();
        //    Combo.DataBind();

        //}

    }
}
