﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using iqbalAddin.Classes;
using Microsoft.Office.Interop.Word;
using Microsoft.Office.Interop.Word;
using Application = System.Windows.Forms.Application;
using View = System.Windows.Forms.View;
using System.Reflection;

namespace iqbalAddin
{
    public partial class frmInsertText : Form
    {
        private string strQry;
        public frmInsertText()
        {
            InitializeComponent();
        }

        private void frmInsertText_Load(object sender, EventArgs e)
        {
            DataBase dbWorkType = new DataBase();
            #region Grid Setting
            // Student List Items.
            lvChapters.View = View.Details;
            // Allow the user to edit item text.
            lvChapters.LabelEdit = false;

            // Allow the user to rearrange columns.
            lvChapters.AllowColumnReorder = true;

            // Select the item and subitems when selection is made.
            lvChapters.FullRowSelect = true;
            // Display grid lines.
            lvChapters.GridLines = true;
            // Sort the items in the list in ascending order.

            lvChapters.Columns.Add("Name", 300, HorizontalAlignment.Left);
            lvChapters.Columns.Add("Id", 0, HorizontalAlignment.Left);


            // Translation List Items.
            lvTranslation.View = View.Details;
            // Allow the user to edit item text.
            lvTranslation.LabelEdit = false;

            // Allow the user to rearrange columns.
            lvTranslation.AllowColumnReorder = true;

            // Select the item and subitems when selection is made.
            lvTranslation.FullRowSelect = true;
            // Display grid lines.
            lvTranslation.GridLines = true;
            // Sort the items in the list in ascending order.

            lvTranslation.Columns.Add("Language", 150, HorizontalAlignment.Left);
            lvTranslation.Columns.Add("Contribution", 300, HorizontalAlignment.Left);
            lvTranslation.Columns.Add("Id", 0, HorizontalAlignment.Left);

            #endregion

            #region Lanugaues
            //Fill Languages
            if (Classes.Cache.LstLanguages.Count == 0)
            {
                strQry =
                    "SELECT Id, titleEnglish, titleOther, directionRTL  FROM languages ORDER BY [titleEnglish];";
                OleDbDataReader dbReader = dbWorkType.GetDataReaders(strQry);
                while (dbReader.Read())
                {
                    languages languagesObj = new languages();
                    languagesObj.Id = Convert.ToInt64(dbReader[0].ToString());
                    languagesObj.TitleEnglish = dbReader[1].ToString();
                    languagesObj.TitleOther = dbReader[2].ToString();
                    languagesObj.DirectionRTL = Convert.ToBoolean(dbReader[3].ToString());
                    Cache.LstLanguages.Add(languagesObj);
                }
                dbReader.Close();
            }

            #endregion

            #region fill Worktype combo
            //Fill Worktype Combo
            if (Classes.Cache.LstWorkType.Count == 0)
            {
                strQry =
                    "SELECT Id, groupTitle FROM mainGroup ORDER BY groupTitle";
                OleDbDataReader dbReader = dbWorkType.GetDataReaders(strQry);
                 while (dbReader.Read())
                {
                    workType workTypeObj = new workType();
                    workTypeObj.Id = Convert.ToInt64(dbReader[0].ToString()) ;
                    workTypeObj.GroupTitle = dbReader[1].ToString();
                     Cache.LstWorkType.Add(workTypeObj);
                }
                dbReader.Close();

            }
            #endregion

            #region Fill Books Groups
            //Fill Books Groups
            if (Classes.Cache.LstBookNames.Count == 0)
            {
                strQry =
                    "SELECT Id, bookGroupName, mainGroupId  FROM bookGroups ORDER BY [bookGroupName];";
                OleDbDataReader dbReader = dbWorkType.GetDataReaders(strQry);
                while (dbReader.Read())
                {
                    bookGroups bookGroupsObj = new bookGroups();
                    bookGroupsObj.Id = Convert.ToInt64(dbReader[0].ToString());
                    bookGroupsObj.BookGroupName = dbReader[1].ToString();
                    bookGroupsObj.MainGroupId = Convert.ToInt64(dbReader[2].ToString());
                    Cache.LstBookGroups.Add(bookGroupsObj);
                }
                dbReader.Close();

            }
            #endregion

            #region Fill Chapters/Poems
            //Fill Chapters/Poems
            if (Classes.Cache.LstChapterGroup.Count == 0)
            {
                strQry =
                    "SELECT Id,bookGroupId, chapterGroupName, hasText, dataOrdering  FROM chapterGroup  ORDER BY [dataOrdering];";
                OleDbDataReader dbReader = dbWorkType.GetDataReaders(strQry);
                while (dbReader.Read())
                {
                    chapterGroup chapterGroupObj = new chapterGroup();
                    chapterGroupObj.Id = Convert.ToInt64(dbReader[0].ToString());
                    chapterGroupObj.BookGroupId = Convert.ToInt64(dbReader[1].ToString());
                    chapterGroupObj.ChapterGroupName = dbReader[2].ToString();
                    chapterGroupObj.HasText =Convert.ToBoolean(dbReader[3].ToString());
                    chapterGroupObj.DataOrdering = Convert.ToInt64(dbReader[4].ToString());
                    Cache.LstChapterGroup.Add(chapterGroupObj);
                }
                dbReader.Close();

            }
            #endregion

            #region Fill Books Names
            if (Classes.Cache.LstBookNames.Count == 0)
            {
                strQry =
                    "SELECT bookNames.Id, bookNames.bookGroupId, bookNames.languageId, languages.titleEnglish, languages.titleOther, " + 
                       "bookNames.bookTitle, bookNames.bookNarration, bookNames.directionRTL, bookNames.contribution, bookNames.original " +
                    " FROM bookNames INNER JOIN languages ON bookNames.languageId = languages.Id;";
                OleDbDataReader dbReader = dbWorkType.GetDataReaders(strQry);
                while (dbReader.Read())
                {
                    bookNames bookNamesObj = new bookNames();
                    bookNamesObj.Id = Convert.ToInt64(dbReader[0].ToString());
                    bookNamesObj.BookGroupId = Convert.ToInt64(dbReader[1].ToString());
                    bookNamesObj.LanguageId = Convert.ToInt64(dbReader[2].ToString());
                    bookNamesObj.LanguageEnglish = dbReader[3].ToString();
                    bookNamesObj.LanguageOthers = dbReader[4].ToString();
                    bookNamesObj.BookTitle = dbReader[5].ToString();
                    bookNamesObj.BookNarration = dbReader[6].ToString();
                    bookNamesObj.DirectionRTL = Convert.ToBoolean(dbReader[7].ToString());
                    bookNamesObj.Contribution = dbReader[8].ToString();
                    bookNamesObj.Original = Convert.ToBoolean(dbReader[9].ToString());
                    Cache.LstBookNames.Add(bookNamesObj);
                }
                dbReader.Close();

            }
            #endregion

            //Fill Combos
            cboWorkType.DataSource = ConvertToDataTable(Cache.LstWorkType);
            cboWorkType.DisplayMember = "GroupTitle";
            cboWorkType.ValueMember = "Id";
            cboWorkType.SelectedIndex = 1;

            dbWorkType.close();
        }

        private void cboWorkType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboWorkType.Items.Count > 0)
            {
                var tmpBookGroups = from p in Cache.LstBookGroups
                                    where p.MainGroupId.Equals(cboWorkType.SelectedValue)
                                    select new
                                               {
                                                   p.Id,
                                                   p.BookGroupName,
                                                   p.MainGroupId
                                               };
                cboBooks.DataSource = ConvertToDataTable(tmpBookGroups.ToList());
                cboBooks.DisplayMember = "BookGroupName";
                cboBooks.ValueMember = "Id";
            }
        }

        private void fillBookNames()
        {

        }

        #region convert to Datatable

        /// <summary>
        /// Convert an IList&lt;T&gt; into a DataTable
        /// </summary>
        /// <example><code>
        /// IList&lt;Person&gt; people = new List&lt;Person&gt;
        ///    {
        ///        new Person { Id= 1, DoB = DateTime.Now, Name = "Bob", Sex = Person.Sexes.Male }
        ///    };
        /// DataTable dt = DataUtil.ConvertToDataTable(people);
        /// </code></example>
        public static DataTable ConvertToDataTable<T>(IList<T> list) where T : class
        {
            DataTable table = CreateDataTable<T>();
            Type objType = typeof(T);
            PropertyDescriptorCollection properties = TypeDescriptor.GetProperties(objType);
            //Debug.WriteLine("foreach (" + objType.Name + " item in list) {");
            foreach (T item in list)
            {
                DataRow row = table.NewRow();
                foreach (PropertyDescriptor property in properties)
                {
                    if (!CanUseType(property.PropertyType)) continue; //shallow only
                    //Debug.WriteLine("row[\"" + property.Name + "\"] = item." + property.Name + "; //.HasValue ? (object)item." + property.Name + ": DBNull.Value;");
                    row[property.Name] = property.GetValue(item) ?? DBNull.Value; //can't use null
                }
                Debug.WriteLine("//===");
                table.Rows.Add(row);
            }
            return table;
        }

        private static bool CanUseType(Type propertyType)
        {
            //only strings and value types
            if (propertyType.IsArray) return false;
            if (!propertyType.IsValueType && propertyType != typeof(string)) return false;
            return true;
        }
        /// <summary>
        /// Convert an IList&lt;T&gt; into a DataTable schema
        /// </summary>
        public static DataTable CreateDataTable<T>() where T : class
        {
            Type objType = typeof(T);
            DataTable table = new DataTable(objType.Name);
            PropertyDescriptorCollection properties = TypeDescriptor.GetProperties(objType);
            foreach (PropertyDescriptor property in properties)
            {
                Type propertyType = property.PropertyType;
                if (!CanUseType(propertyType)) continue; //shallow only

                //nullables must use underlying types
                if (propertyType.IsGenericType && propertyType.GetGenericTypeDefinition() == typeof(Nullable<>))
                    propertyType = Nullable.GetUnderlyingType(propertyType);
                //enums also need special treatment
                if (propertyType.IsEnum)
                    propertyType = Enum.GetUnderlyingType(propertyType); //probably Int32
                //if you have nested application classes, they just get added. Check if this is valid?
                Debug.WriteLine("table.Columns.Add(\"" + property.Name + "\", typeof(" + propertyType.Name + "));");
                table.Columns.Add(property.Name, propertyType);
            }
            return table;
        }
#endregion

        private void cboBooks_SelectedIndexChanged(object sender, EventArgs e)
        {
            #region fill Peom/Chapters
            if (cboBooks.Items.Count > 0)
            {
                var tmpBookGroups = (from p in Cache.LstChapterGroup
                                    where p.BookGroupId.Equals(cboBooks.SelectedValue)
                                    select new
                                    {
                                        p.Id,
                                        p.ChapterGroupName,
                                        p.DataOrdering
                                    }).OrderBy(x => x.DataOrdering);
                lvChapters.Items.Clear();
                foreach (var tmpBookGroupObj in tmpBookGroups)
                {
                    ListViewItem lst = new ListViewItem(tmpBookGroupObj.ChapterGroupName);
                    lst.SubItems.Add(tmpBookGroupObj.Id.ToString());
                    lvChapters.Items.Add(lst);
                }
            }
            #endregion

            #region fill Translations
            if (cboBooks.Items.Count > 0)
            {
                var tmpBookNames = (from p in Cache.LstBookNames
                                     where p.BookGroupId.Equals(cboBooks.SelectedValue) && p.Original.Equals(false)
                                     select new
                                     {
                                         p.Id,
                                         p.LanguageEnglish,
                                         p.LanguageOthers,
                                         p.BookTitle,
                                         p.Contribution,
                                         p.DirectionRTL,
                                         p.BookGroupId
                                     }).OrderBy(x => x.LanguageEnglish);
                lvTranslation.Items.Clear();
                foreach (var tmpBookNamesObj in tmpBookNames)
                {
                    ListViewItem lst = new ListViewItem(tmpBookNamesObj.LanguageEnglish + "(" + tmpBookNamesObj.LanguageOthers + ")");
                    lst.SubItems.Add(tmpBookNamesObj.Contribution.ToString());
                    lst.SubItems.Add(tmpBookNamesObj.Id.ToString());
                    lvTranslation.Items.Add(lst);
                }
            }
            #endregion

        }

        private void btnInsert_Click(object sender, EventArgs e)
        {

            
            Microsoft.Office.Interop.Word.Application app = Globals.allamaIqbalAddin.Application;
            Microsoft.Office.Interop.Word.Document activeDoc = app.ActiveDocument;
            DataBase dbIqbalWork = new DataBase();
            string strReference = "";
            long Id;
            string titleChapter;
            string txtData;
            string contribution;
            bool directionRTL;
            int lenTxtData;
            long bookNameId;
            if (activeDoc == null) return;

            if (lvChapters.CheckedItems.Count==0)
            {
                MessageBox.Show("Please select some Chapter/Poem from List", "Iqbal's Poetry", MessageBoxButtons.OK,
                                MessageBoxIcon.Warning);
            }
            else
            {
                #region get Selected Translation Ids
                string selectedTranslation = "(";
                if (chkTranslation.Checked == true)
                {
                   for (int i=0;i<lvTranslation.CheckedItems.Count;i++)
                   {
                       selectedTranslation = selectedTranslation + lvTranslation.CheckedItems[i].SubItems[2].Text + ",";
                   }
                    selectedTranslation.Substring(0, selectedTranslation.Length - 1);
                    selectedTranslation = selectedTranslation + ")";
                }
                else
                {
                    selectedTranslation="(0)";
                }
                #endregion
                for (int i = 0; i < lvChapters.CheckedItems.Count; i++)
                {
                    strQry = "SELECT Id, titleChapter,len(txtData) AS lenTxtData1, txtData, contribution, directionRTL,bookNameId FROM chapterData WHERE Original=Yes AND chapterGroupId=" + lvChapters.CheckedItems[i].SubItems[1].Text;
                    OleDbDataReader dbReader = dbIqbalWork.GetDataReaders(strQry);
                    while (dbReader.Read())
                    {
                        #region Orginal Language
                        Id = Convert.ToInt64(dbReader["Id"].ToString());
                        titleChapter = dbReader["titleChapter"].ToString();
                        lenTxtData = Convert.ToInt32(dbReader["lenTxtData1"].ToString()); 

                        char[] txtDataBuffered = new char[lenTxtData ];
                        long retVal = dbReader.GetChars(3, 0, txtDataBuffered, 0, lenTxtData );
                        contribution = dbReader["contribution"].ToString();
                        directionRTL = Convert.ToBoolean(dbReader["directionRTL"].ToString());
                        bookNameId=Convert.ToInt64(dbReader["bookNameId"].ToString());
                            
                        app.Selection.TypeParagraph();
                        string txtDataString = new string(txtDataBuffered);

                        bookNames bookNamesTmp = Cache.LstBookNames.ToList().Find(x => x.Id.Equals(bookNameId));

                        if (directionRTL == true)
                        {
                            app.Selection.RtlPara();
                            app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphRight;
                            app.Selection.TypeText(txtDataString);
                            if (chkReferences.Checked==true)
                            {
                                app.Selection.TypeParagraph();
                                app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphLeft;
                                app.Selection.TypeText(titleChapter + ", ");
                                app.Selection.Font.Italic =1;
                                app.Selection.Font.Bold = 1;
                                app.Selection.TypeText( bookNamesTmp.BookTitle );
                                app.Selection.Font.Bold = 0;
                                app.Selection.Font.Italic = 0;
                                app.Selection.TypeText(" [" + contribution + "]");
                            }
                        }
                        else
                        {
                            app.Selection.LtrPara();
                            app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphLeft;
                            app.Selection.TypeText(txtDataString);
                            app.Selection.TypeParagraph();
                            if (chkReferences.Checked == true)
                            {
                                app.Selection.TypeParagraph();
                                app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphRight;
                                app.Selection.TypeText(titleChapter + ", ");
                                app.Selection.Font.Italic = 1;
                                app.Selection.Font.Bold = 1;
                                app.Selection.TypeText(bookNamesTmp.BookTitle);
                                app.Selection.Font.Bold = 0;
                                app.Selection.Font.Italic = 0;
                                app.Selection.TypeText(" [" + contribution + "]");
                            }
                        }
                        app.Selection.TypeParagraph();
                        #endregion
                        #region Translations

                        strQry =  "SELECT Id, titleChapter,len(txtData) AS lenTxtData1, txtData, contribution, directionRTL, bookNameId FROM chapterData WHERE Original=No AND chapterGroupId=" + lvChapters.CheckedItems[i].SubItems[1].Text +
                            " AND bookNameId IN " + selectedTranslation;
                        OleDbDataReader dbReader1 = dbIqbalWork.GetDataReaders(strQry);
                        while (dbReader1.Read())
                        {
                            Id = Convert.ToInt64(dbReader1["Id"].ToString());
                            titleChapter = dbReader1["titleChapter"].ToString();
                            lenTxtData = Convert.ToInt32(dbReader1["lenTxtData1"].ToString());

                            txtDataBuffered = new char[lenTxtData];
                            retVal = dbReader1.GetChars(3, 0, txtDataBuffered, 0, lenTxtData);
                            contribution = dbReader1["contribution"].ToString();
                            directionRTL = Convert.ToBoolean(dbReader1["directionRTL"].ToString());
                            bookNameId = Convert.ToInt64(dbReader1["bookNameId"].ToString());

                            app.Selection.TypeParagraph();
                            txtDataString = new string(txtDataBuffered);

                            bookNamesTmp = Cache.LstBookNames.ToList().Find(x => x.Id.Equals(bookNameId));

                            if (directionRTL == true)
                            {
                                app.Selection.RtlPara();
                                app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphRight;
                                app.Selection.TypeText(txtDataString);
                                if (chkReferences.Checked == true)
                                {
                                    app.Selection.TypeParagraph();
                                    app.Selection.ParagraphFormat.Alignment =
                                        WdParagraphAlignment.wdAlignParagraphLeft;
                                    app.Selection.TypeText(titleChapter + ", ");
                                    app.Selection.Font.Italic = 1;
                                    app.Selection.Font.Bold = 1;
                                    app.Selection.TypeText(bookNamesTmp.BookTitle);
                                    app.Selection.Font.Bold = 0;
                                    app.Selection.Font.Italic = 0;
                                    app.Selection.TypeText(" [" + contribution + "]");
                                }
                            }
                            else
                            {
                                app.Selection.LtrPara();
                                app.Selection.ParagraphFormat.Alignment = WdParagraphAlignment.wdAlignParagraphLeft;
                                app.Selection.TypeText(txtDataString);
                                app.Selection.TypeParagraph();
                                if (chkReferences.Checked == true)
                                {
                                    app.Selection.TypeParagraph();
                                    app.Selection.ParagraphFormat.Alignment =
                                        WdParagraphAlignment.wdAlignParagraphRight;
                                    app.Selection.TypeText(titleChapter + ", ");
                                    app.Selection.Font.Italic = 1;
                                    app.Selection.Font.Bold = 1;
                                    app.Selection.TypeText(bookNamesTmp.BookTitle);
                                    app.Selection.Font.Bold = 0;
                                    app.Selection.Font.Italic = 0;
                                    app.Selection.TypeText(" [" + contribution + "]");
                                }
                            }
                            app.Selection.TypeParagraph();
                        }
                        #endregion
                        dbReader1.Close();
                    }
                    dbReader.Close();
                }
                MessageBox.Show("Data Inserted to in Document", "Iqbal's Work", MessageBoxButtons.OK,
                                        MessageBoxIcon.Information);
            }
        }
    }
}
